## qubes-gui-daemon 4.1.0

=== Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

MANDIR ?= /usr/share/man
LIBDIR ?= /usr/lib64

help:
	@echo "Qubes GUI main Makefile:" ;\
	    echo "make all                  <--- build binaries";\
	    echo "make all                  <--- install files into \$$DESTDIR";\
	    echo "make clean                <--- clean all the binary files";\
	    @exit 0;

all: gui-daemon/qubes-guid shmoverride/shmoverride.so shmoverride/X-wrapper-qubes \
		pulse/pacat-simple-vchan screen-layout-handler/watch-screen-layout-changes

gui-daemon/qubes-guid:
	(cd gui-daemon; $(MAKE))

shmoverride/shmoverride.so:
	(cd shmoverride; $(MAKE) shmoverride.so)

shmoverride/X-wrapper-qubes:
	(cd shmoverride; $(MAKE) X-wrapper-qubes)
	
pulse/pacat-simple-vchan:
	$(MAKE) -C pulse pacat-simple-vchan

screen-layout-handler/watch-screen-layout-changes:
	$(MAKE) -C screen-layout-handler watch-screen-layout-changes

install:
	install -D gui-daemon/qubes-guid $(DESTDIR)/usr/bin/qubes-guid
	install -m 0644 -D gui-daemon/qubes-guid.1 $(DESTDIR)$(MANDIR)/man1/qubes-guid.1
	install -D pulse/pacat-simple-vchan $(DESTDIR)/usr/bin/pacat-simple-vchan
	install -D -m 0644 pulse/pacat-control-api.xml $(DESTDIR)/usr/share/dbus-1/interfaces/org.qubesos.Audio.xml
	install -D -m 0644 pulse/org.qubesos.Audio.conf $(DESTDIR)/etc/dbus-1/system.d/org.qubesos.Audio.conf
	install -D shmoverride/X-wrapper-qubes $(DESTDIR)/usr/bin/X-wrapper-qubes
	install -D shmoverride/shmoverride.so $(DESTDIR)$(LIBDIR)/qubes-gui-daemon/shmoverride.so
	install -D -m 0644 gui-daemon/guid.conf $(DESTDIR)/etc/qubes/guid.conf
	install -D gui-daemon/qubes-localgroup.sh $(DESTDIR)/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
	install -D -m 0644 gui-daemon/qubes.ClipboardPaste.policy $(DESTDIR)/etc/qubes-rpc/policy/qubes.ClipboardPaste
	install -D screen-layout-handler/watch-screen-layout-changes $(DESTDIR)/usr/libexec/qubes/watch-screen-layout-changes
	install -D -m 0644 screen-layout-handler/qubes-screen-layout-watches.desktop $(DESTDIR)/etc/xdg/autostart/qubes-screen-layout-watches.desktop
	$(MAKE) -C window-icon-updater install

tar:
	git archive --format=tar --prefix=qubes-gui/ HEAD -o qubes-gui.tar

clean:
	(cd common; $(MAKE) clean)
	(cd gui-common; $(MAKE) clean)
	(cd gui-daemon; $(MAKE) clean)
	(cd shmoverride; $(MAKE) clean)
	$(MAKE) -C pulse clean

=== gui-daemon/Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

CC=gcc
CFLAGS+=-I../include/ -g -O2 -Wall -Wextra -Werror -pie -fPIC \
		`pkg-config --cflags libconfig` \
		`pkg-config --cflags libnotify` \
		`pkg-config --cflags libpng` \
		`pkg-config --cflags vchan-$(BACKEND_VMM)`
OBJS=xside.o png.o trayicon.o ../gui-common/double-buffer.o ../gui-common/txrx-vchan.o \
	../gui-common/error.o ../common/list.o

all: qubes-guid qubes-guid.1
qubes-guid: $(OBJS)
	$(CC) -g -pie -o qubes-guid $(OBJS) \
		-lX11 -lXext -Wall -lm \
		`pkg-config --libs vchan-$(BACKEND_VMM)` \
		`pkg-config --libs libpng` \
		`pkg-config --libs libconfig` \
		`pkg-config --libs libnotify`

qubes-guid.1: qubes-guid
	help2man --version-string=`cat ../version` --no-info --name="Qubes GUI daemon" ./qubes-guid  > qubes-guid.1

clean:
	rm -f qubes-guid *.o *~

=== pulse/Makefile ===
CC=gcc
CFLAGS=-Wall -Wextra -Werror -g -O2
VCHANLIBS=`pkg-config --libs vchan-$(BACKEND_VMM)`
VCHANCFLAGS=`pkg-config --cflags vchan-$(BACKEND_VMM)`
GLIBCFLAGS=`pkg-config --cflags glib-2.0` `pkg-config --cflags dbus-glib-1`
GLIBLIBS=`pkg-config --libs glib-2.0` `pkg-config --libs dbus-glib-1` `pkg-config --libs gthread-2.0`
all: module-vchan-sink.so pacat-simple-vchan
pacat-simple-vchan.o: pacat-simple-vchan.c
	$(CC) $(CFLAGS) -c $(VCHANCFLAGS) -I. $(GLIBCFLAGS) pacat-simple-vchan.c
pacat-control-object.o: pacat-control-object.c pacat-control-object.h pacat-control-stub.h
	$(CC) $(CFLAGS) -c $(VCHANCFLAGS) -I. $(GLIBCFLAGS) $<
pacat-simple-vchan: pacat-simple-vchan.o pacat-control-object.o
	$(CC) -o pacat-simple-vchan $^ \
		$(VCHANLIBS) -lpulse -lpulse-mainloop-glib $(GLIBLIBS)
# Do not autogenerate because dbus-binding-tool from dbus-glib-0.86 (in chroot)
# produces output incompatible with dbus-glib-0.84 (in Qubes dom0).
#pacat-control-stub.h: pacat-control-api.xml
#	dbus-binding-tool --mode=glib-server --prefix=pacat-control $< > $@
clean:
	rm -f *.so *.o pacat-simple-vchan *~

=== shmoverride/Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

CFLAGS+=-g -O2 -I../include/ -fPIC -Wall -Wextra -Werror \
		-DBACKEND_VMM_$(BACKEND_VMM) \
		-DSHMOVERRIDE_LIB_PATH=\"$(LIBDIR)/qubes-gui-daemon/shmoverride.so\"
CC=gcc

all: shmoverride.so X-wrapper-qubes

shmoverride.so: shmoverride.o list.o
	gcc -shared -o shmoverride.so \
		shmoverride.o list.o -ldl -lxenctrl -lxengnttab

list.o: ../common/list.c
	$(CC) $(CFLAGS) -shared -c -o list.o ../common/list.c

X-wrapper-qubes: X-wrapper-qubes.o

clean:
	rm -f *~ *.o shmoverride.so X-wrapper-qubes

=== debian/changelog ===
qubes-gui-daemon (4.1.0-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Sat, 02 Mar 2019 14:57:16 +0100

qubes-gui-daemon (4.1.0-1) unstable; urgency=medium

  * Initial packaging

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 02 Mar 2019 14:57:16 +0100

## qubes-gui-daemon 4.1.1

=== debian/changelog ===
qubes-gui-daemon (4.1.1-1+deb10u1) buster; urgency=medium

  * Build for buster

 -- Builder <user@localhost>  Fri, 29 Mar 2019 01:00:07 +0100

qubes-gui-daemon (4.1.1-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * xside: save agent protocol version

  [ Your Name ]
  * CLIPBOARD_DATA: fix sending of window id when pasting to messages.

  [ Marek Marczykowski-Górecki ]
  * xside: send old MSG_CLIPBOARD_DATA if agent is old
  * rpm: use %{python3_pkgversion} to make it CentOS compatible

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 29 Mar 2019 01:00:07 +0100

## qubes-gui-daemon 4.1.2

=== debian/changelog ===
qubes-gui-daemon (4.1.2-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 20 Apr 2019 18:16:14 +0200

qubes-gui-daemon (4.1.2-1) wheezy; urgency=medium

  * Fix setting shmoverride.so localtion

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 20 Apr 2019 18:16:14 +0200

## qubes-gui-daemon 4.1.3

=== Makefile ===
--- 
+++ 
@@ -21,6 +21,7 @@
 
 MANDIR ?= /usr/share/man
 LIBDIR ?= /usr/lib64
+export LIBDIR
 
 help:
 	@echo "Qubes GUI main Makefile:" ;\

=== window-icon-updater/Makefile ===
all:
	@true

install:
	install -D icon-receiver $(DESTDIR)/usr/lib/qubes/icon-receiver
	install -m 0644 -D qubes.WindowIconUpdater $(DESTDIR)/etc/qubes-rpc
	install -m 0664 -D qubes.WindowIconUpdater.policy $(DESTDIR)/etc/qubes-rpc/policy/qubes.WindowIconUpdater

=== debian/changelog ===
qubes-gui-daemon (4.1.3-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Sun, 05 Jan 2020 20:03:31 +0100

qubes-gui-daemon (4.1.3-1) unstable; urgency=medium

  [ xaki23 ]
  * allow domid 0 as target

  [ Frédéric Pierret (fepitre) ]
  * travis: switch to bionic

  [ Snowy Marmot ]
  * Add exmaples/comments to guid.conf
  * Review and fix spelling

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 05 Jan 2020 20:03:31 +0100

## qubes-gui-daemon 4.1.4

=== window-icon-updater/Makefile ===
all:
	@true

install:
	install -D icon-receiver $(DESTDIR)/usr/lib/qubes/icon-receiver
	install -D qubes.WindowIconUpdater $(DESTDIR)/etc/qubes-rpc
	install -m 0664 -D qubes.WindowIconUpdater.policy $(DESTDIR)/etc/qubes-rpc/policy/qubes.WindowIconUpdater

=== debian/changelog ===
qubes-gui-daemon (4.1.4-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Sun, 15 Mar 2020 03:00:41 +0100

qubes-gui-daemon (4.1.4-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * travis: switch to dom0 Fedora 31

  [ Marek Marczykowski-Górecki ]
  * Make files in qubes-rpc executable
  * Make qubes.WindowIconUpdater a proper script
  * Fix tray icon coloring code - do not crop/dislocate icon fragments

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 15 Mar 2020 03:00:41 +0100

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DESTDIR=$(shell pwd)/debian/tmp
export LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ --with config-package

override_dh_auto_build:
	make all

override_dh_auto_install:
	dh_auto_install
	mv $(DESTDIR)/usr/bin/X-wrapper-qubes $(DESTDIR)/usr/bin/X.qubes

override_dh_install:
	dh_install --fail-missing


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## qubes-gui-daemon 4.1.5

=== Makefile ===
--- 
+++ 
@@ -52,8 +52,8 @@
 	install -D gui-daemon/qubes-guid $(DESTDIR)/usr/bin/qubes-guid
 	install -m 0644 -D gui-daemon/qubes-guid.1 $(DESTDIR)$(MANDIR)/man1/qubes-guid.1
 	install -D pulse/pacat-simple-vchan $(DESTDIR)/usr/bin/pacat-simple-vchan
-	install -D -m 0644 pulse/pacat-control-api.xml $(DESTDIR)/usr/share/dbus-1/interfaces/org.qubesos.Audio.xml
-	install -D -m 0644 pulse/org.qubesos.Audio.conf $(DESTDIR)/etc/dbus-1/system.d/org.qubesos.Audio.conf
+	install -D pulse/qubes.AudioInputEnable $(DESTDIR)/etc/qubes-rpc/qubes.AudioInputEnable
+	install -D pulse/qubes.AudioInputDisable $(DESTDIR)/etc/qubes-rpc/qubes.AudioInputDisable
 	install -D shmoverride/X-wrapper-qubes $(DESTDIR)/usr/bin/X-wrapper-qubes
 	install -D shmoverride/shmoverride.so $(DESTDIR)$(LIBDIR)/qubes-gui-daemon/shmoverride.so
 	install -D -m 0644 gui-daemon/guid.conf $(DESTDIR)/etc/qubes/guid.conf

=== shmoverride/Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 #
 #
 
+LIBDIR ?= /usr/lib64
 CFLAGS+=-g -O2 -I../include/ -fPIC -Wall -Wextra -Werror \
 		-DBACKEND_VMM_$(BACKEND_VMM) \
 		-DSHMOVERRIDE_LIB_PATH=\"$(LIBDIR)/qubes-gui-daemon/shmoverride.so\"

=== debian/changelog ===
qubes-gui-daemon (4.1.5-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Fri, 10 Apr 2020 05:56:54 +0200

qubes-gui-daemon (4.1.5-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * gui-daemon: set qubes-keyboard only in dom0
  * qubes-release: define it in xside.h

  [ Paweł Marczewski ]
  * shmoverride: handle Xorg crash leaving shm.id file
  * Convert qubes.WindowIconUpdater to a socket service
  * qubes.WindowIconUpdater: use wait-for-session
  * Add dependencies for qubes.WindowIconUpdater
  * icon-receiver: use logging
  * icon-receiver: handle app.domains updates

  [ M. Vefa Bicakci ]
  * xside: Introduce override_redirect protection

  [ Paweł Marczewski ]
  * Support MSG_CURSOR
  * Define supported protocol version

  [ Marek Marczykowski-Górecki ]
  * pulse: periodically check if vchan connection is alive
  * pulse: create pidfile

  [ Frédéric Pierret (fepitre) ]
  * Currently disable failing builds for CentOS 7
  * xside: drop related pulseaudio (done in qvm-start-daemon)
  * spec: put audio part in subpackage

  [ Marek Marczykowski-Górecki ]
  * pulse: fix compiler warning
  * rpm: pull in audio packages on dom0 upgrade
  * pulse: replace dbus control with QubesDB + local socket
  * pulse: add qrexec services to control audio-input in another VM
  * rpm: use rpm-build provided CFLAGS for pacat-simple-vchan
  * Update core-admin extension for new audio-input control mechanism
  * rpm: require new enough qubes-core-dom0
  * Revert "Currently disable failing builds for CentOS 7"
  * travis: add CentOS 7

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 10 Apr 2020 05:56:54 +0200

## qubes-gui-daemon 4.1.6

=== debian/changelog ===
qubes-gui-daemon (4.1.6-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sun, 17 May 2020 12:37:45 +0200

qubes-gui-daemon (4.1.6-1) unstable; urgency=medium

  [ Ivan Kardykov ]
  * set override redirect attribute on window creating

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 17 May 2020 12:37:45 +0200

## qubes-gui-daemon 4.1.7

=== debian/changelog ===
qubes-gui-daemon (4.1.7-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Wed, 15 Jul 2020 13:50:45 +0200

qubes-gui-daemon (4.1.7-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * shmoverride: fill shm_perm when faking shmctl(IPC_STAT) output
  * Update dependencies for icon receiver

  [ Dmitry Fedorov ]
  * audio: register vchan' callbacks when stream in PA_STREAM_READY
    state
  * audio: fix indentation
  * audio: quit if io_new() fails

  [ Paweł Marczewski ]
  * Allow overriding configuration file
  * Remove audio_low_latency option (not used anymore)
  * Add a warning to the configuration file

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 15 Jul 2020 13:50:45 +0200

=== debian/control ===
Source: qubes-gui-daemon
Section: admin
Priority: optional
Maintainer: Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>
Build-Depends:
 debhelper (>= 10),
 qubes-gui-common,
 config-package-dev,
 libxen-dev,
 libvchan-xen-dev,
 python3-dev,
 libpulse-dev,
 libxt-dev,
 libxext-dev,
 libxrandr-dev,
 libconfig-dev,
 libpng-dev,
 libnotify-dev,
 qubesdb-dev,
 help2man
Standards-Version: 4.1.3
Homepage: https://qubes-os.org/
#Vcs-Browser: https://github.com/QubesOS/qubes-gui-daemon
#Vcs-Git: https://github.com/QubesOS/qubes-gui-daemon.git

Package: qubes-gui-daemon
Architecture: any
Depends:
 python3-xcffib,
 xserver-xorg-core,
 python3,
 qubes-core-qrexec (>= 4.1.5),
 python3-qubesimgconverter (>= 4.1.4),
 socat,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 qubes-gui-daemon-pulseaudio
Provides: ${diverted-files}
Conflicts: ${diverted-files}
Description: Qubes GUI virtualization (GUI VM side)
 The Qubes GUI virtualization infrastructure that needs to be installed in GUI
 VM.

Package: qubes-gui-daemon-pulseaudio
Architecture: any
Depends:
 pulseaudio,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Qubes audio virtualization (GUI/Audio VM side)
 The GUI/Audio VM side of Qubes audio virtualization.

## qubes-gui-daemon 4.1.8

=== pulse/Makefile ===
CC ?= gcc
CFLAGS += -Wall -Wextra -Werror -g -O2
VCHANLIBS=`pkg-config --libs vchan-$(BACKEND_VMM)`
VCHANCFLAGS=`pkg-config --cflags vchan-$(BACKEND_VMM)`
GLIBCFLAGS=`pkg-config --cflags glib-2.0`
GLIBLIBS=`pkg-config --libs glib-2.0`
all: module-vchan-sink.so pacat-simple-vchan
pacat-simple-vchan.o: pacat-simple-vchan.c
	$(CC) $(CFLAGS) -c $(VCHANCFLAGS) -I. $(GLIBCFLAGS) pacat-simple-vchan.c
pacat-simple-vchan: pacat-simple-vchan.o
	$(CC) -o pacat-simple-vchan $^ \
		$(VCHANLIBS) -lpulse -lpulse-mainloop-glib -lqubesdb $(GLIBLIBS)
clean:
	rm -f *.so *.o pacat-simple-vchan *~

=== debian/changelog ===
qubes-gui-daemon (4.1.8-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 30 Jul 2020 05:01:47 +0200

qubes-gui-daemon (4.1.8-1) unstable; urgency=medium

  [ Paweł Marczewski ]
  * Prevent VM notifications from appearing on top of xscreensaver
  * Make screensaver detection configurable
  * Handle destroyed windows in restack_windows

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 30 Jul 2020 05:01:47 +0200

## qubes-gui-daemon 4.1.9

=== debian/changelog ===
qubes-gui-daemon (4.1.9-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Mon, 31 Aug 2020 04:20:14 +0200

qubes-gui-daemon (4.1.9-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Update travis

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 31 Aug 2020 04:20:14 +0200

## qubes-gui-daemon 4.1.10

=== debian/changelog ===
qubes-gui-daemon (4.1.10-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Fri, 18 Sep 2020 05:15:19 +0200

qubes-gui-daemon (4.1.10-1) unstable; urgency=medium

  [ John Hensley ]
  * icon-receiver: exit on X connection error

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 18 Sep 2020 05:15:19 +0200

## qubes-gui-daemon 4.1.11

=== debian/changelog ===
qubes-gui-daemon (4.1.11-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Fri, 13 Nov 2020 03:15:42 +0100

qubes-gui-daemon (4.1.11-1) unstable; urgency=medium

  * Fix handling X11 exit
  * xside: don't hang indefinitely if VM is killed early

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 13 Nov 2020 03:15:42 +0100

## qubes-gui-daemon 4.1.12

=== gui-daemon/Makefile ===
--- 
+++ 
@@ -19,12 +19,13 @@
 #
 #
 
+VCHAN_PKG = $(if $(BACKEND_VMM),vchan-$(BACKEND_VMM),vchan)
 CC=gcc
 CFLAGS+=-I../include/ -g -O2 -Wall -Wextra -Werror -pie -fPIC \
 		`pkg-config --cflags libconfig` \
 		`pkg-config --cflags libnotify` \
 		`pkg-config --cflags libpng` \
-		`pkg-config --cflags vchan-$(BACKEND_VMM)`
+		`pkg-config --cflags $(VCHAN_PKG)`
 OBJS=xside.o png.o trayicon.o ../gui-common/double-buffer.o ../gui-common/txrx-vchan.o \
 	../gui-common/error.o ../common/list.o
 
@@ -32,13 +33,13 @@
 qubes-guid: $(OBJS)
 	$(CC) -g -pie -o qubes-guid $(OBJS) \
 		-lX11 -lXext -Wall -lm \
-		`pkg-config --libs vchan-$(BACKEND_VMM)` \
+		`pkg-config --libs $(VCHAN_PKG)` \
 		`pkg-config --libs libpng` \
 		`pkg-config --libs libconfig` \
 		`pkg-config --libs libnotify`
 
 qubes-guid.1: qubes-guid
-	help2man --version-string=`cat ../version` --no-info --name="Qubes GUI daemon" ./qubes-guid  > qubes-guid.1
+	LC_ALL=C help2man --version-string=`cat ../version` --no-info --name="Qubes GUI daemon" ./qubes-guid  > qubes-guid.1
 
 clean:
 	rm -f qubes-guid *.o *~

=== shmoverride/Makefile ===
--- 
+++ 
@@ -20,6 +20,12 @@
 #
 #
 
+BACKEND_VMM_PKGCONFIG = $(shell pkg-config --variable=backend_vmm vchan)
+BACKEND_VMM ?= $(firstword $(BACKEND_VMM_PKGCONFIG) xen)
+ifneq ($(BACKEND_VMM),xen)
+$(error shmoverride currently supports Xen only, '$(BACKEND_VMM)' set)
+endif
+
 LIBDIR ?= /usr/lib64
 CFLAGS+=-g -O2 -I../include/ -fPIC -Wall -Wextra -Werror \
 		-DBACKEND_VMM_$(BACKEND_VMM) \

=== debian/changelog ===
qubes-gui-daemon (4.1.12-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Wed, 06 Jan 2021 21:44:44 +0100

qubes-gui-daemon (4.1.12-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * More protection vs override redirect windows
  * Use --override-redirect=disabled
  * Use the work area instead of root window size

  [ Frédéric Pierret (fepitre) ]
  * Add .gitlab-ci.yml

  [ Marek Marczykowski-Górecki ]
  * gitlab-ci: adjust install excludes
  * Make the build detect BACKEND_VMM based on installed vchan version

  [ Demi Marie Obenour ]
  * Listen for property changes instead of polling
  * Respond to code review from @marmarek
  * Remove hard-coded magic numbers
  * Use desktop_coordinates_size instead of a magic number
  * Don’t crash if there is no window manager
  * Miscellaneous hardening
  * Replace /var/run with /run
  * Check syscall return values
  * Never pass an invalid X11 operation to dom0

  [ Frédéric Pierret (fepitre) ]
  * Enforce locale for help2man

  [ Marek Marczykowski-Górecki ]
  * Fix clipboard stop working after ~50 days of uptime

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 06 Jan 2021 21:44:44 +0100

## qubes-gui-daemon 4.1.13

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 	    echo "make all                  <--- build binaries";\
 	    echo "make all                  <--- install files into \$$DESTDIR";\
 	    echo "make clean                <--- clean all the binary files";\
-	    @exit 0;
+	    exit 0;
 
 all: gui-daemon/qubes-guid shmoverride/shmoverride.so shmoverride/X-wrapper-qubes \
 		pulse/pacat-simple-vchan screen-layout-handler/watch-screen-layout-changes

=== debian/changelog ===
qubes-gui-daemon (4.1.13-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Fri, 18 Jun 2021 05:44:25 +0200

qubes-gui-daemon (4.1.13-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Move XInternAtom calls to startup
  * Miscellaneous cleanups
  * Avoid dangerous functions in shmoverride
  * Remove @asyncio.coroutine
  * Rip out @asyncio.coroutine
  * Remove deprecated qrexec policy syntax
  * Support clipboard outside of dom0

  [ Marek Marczykowski-Górecki ]
  * rpm: require qrexec new enough for policy.EvalSimple service

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 18 Jun 2021 05:44:25 +0200

## qubes-gui-daemon 4.1.14

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,8 @@
 
 MANDIR ?= /usr/share/man
 LIBDIR ?= /usr/lib64
-export LIBDIR
+VCHAN_PKG ?= vchan-xen
+export LIBDIR CFLAGS
 
 help:
 	@echo "Qubes GUI main Makefile:" ;\
@@ -30,11 +31,12 @@
 	    echo "make clean                <--- clean all the binary files";\
 	    exit 0;
 
-all: gui-daemon/qubes-guid shmoverride/shmoverride.so shmoverride/X-wrapper-qubes \
-		pulse/pacat-simple-vchan screen-layout-handler/watch-screen-layout-changes
+all: gui-daemon/qubes-guid gui-daemon/qubes-guid.1 shmoverride/shmoverride.so \
+     shmoverride/X-wrapper-qubes pulse/pacat-simple-vchan \
+     screen-layout-handler/watch-screen-layout-changes
 
-gui-daemon/qubes-guid:
-	(cd gui-daemon; $(MAKE))
+gui-daemon/qubes-guid gui-daemon/qubes-guid.1:
+	$(MAKE) -C gui-daemon qubes-guid qubes-guid.1
 
 shmoverride/shmoverride.so:
 	(cd shmoverride; $(MAKE) shmoverride.so)

=== gui-daemon/Makefile ===
--- 
+++ 
@@ -19,27 +19,26 @@
 #
 #
 
+MAKEFLAGS := -rR
 VCHAN_PKG = $(if $(BACKEND_VMM),vchan-$(BACKEND_VMM),vchan)
 CC=gcc
-CFLAGS+=-I../include/ -g -O2 -Wall -Wextra -Werror -pie -fPIC \
-		`pkg-config --cflags libconfig` \
-		`pkg-config --cflags libnotify` \
-		`pkg-config --cflags libpng` \
-		`pkg-config --cflags $(VCHAN_PKG)`
-OBJS=xside.o png.o trayicon.o ../gui-common/double-buffer.o ../gui-common/txrx-vchan.o \
-	../gui-common/error.o ../common/list.o
-
-all: qubes-guid qubes-guid.1
-qubes-guid: $(OBJS)
-	$(CC) -g -pie -o qubes-guid $(OBJS) \
-		-lX11 -lXext -Wall -lm \
-		`pkg-config --libs $(VCHAN_PKG)` \
-		`pkg-config --libs libpng` \
-		`pkg-config --libs libconfig` \
-		`pkg-config --libs libnotify`
+pkgs := x11 xext x11-xcb xcb glib-2.0 $(VCHAN_PKG) libpng libnotify libconfig
+objs := xside.o png.o trayicon.o ../gui-common/double-buffer.o ../gui-common/txrx-vchan.o \
+	../gui-common/error.o list.o
+extra_cflags := -I../include/ -g -O2 -Wall -Wextra -Werror -pie -fPIC \
+		$(shell pkg-config --cflags $(pkgs))
+LDLIBS := $(shell pkg-config --libs $(pkgs))
+all: qubes-guid # qubes-guid.1
+vpath %.c ../common
+qubes-guid: $(objs)
+	$(CC) -g -pie -o qubes-guid $(objs) -Wall -lm $(LDLIBS) $(LDFLAGS)
 
 qubes-guid.1: qubes-guid
 	LC_ALL=C help2man --version-string=`cat ../version` --no-info --name="Qubes GUI daemon" ./qubes-guid  > qubes-guid.1
 
 clean:
-	rm -f qubes-guid *.o *~
+	rm -f qubes-guid ./*.o ./*~
+
+%.o: %.c Makefile
+	$(CC) -MD -MP -MF $@.dep -c -o $@ $(extra_cflags) $(CFLAGS) $<
+-include *.dep

=== shmoverride/Makefile ===
--- 
+++ 
@@ -27,21 +27,25 @@
 endif
 
 LIBDIR ?= /usr/lib64
-CFLAGS+=-g -O2 -I../include/ -fPIC -Wall -Wextra -Werror \
+extra_cflags := -g -O2 -I../include/ -fPIC -Wall -Wextra -Werror \
 		-DBACKEND_VMM_$(BACKEND_VMM) \
-		-DSHMOVERRIDE_LIB_PATH=\"$(LIBDIR)/qubes-gui-daemon/shmoverride.so\"
+		-DSHMOVERRIDE_LIB_PATH=\"$(LIBDIR)/qubes-gui-daemon/shmoverride.so\" \
+		-I../include
 CC=gcc
 
 all: shmoverride.so X-wrapper-qubes
 
-shmoverride.so: shmoverride.o list.o
-	gcc -shared -o shmoverride.so \
+shmoverride.so: shmoverride.o ./list.o
+	$(CC) $(CFLAGS) $(extra_cflags) -shared -o shmoverride.so \
 		shmoverride.o list.o -ldl -lxenctrl -lxengnttab
 
-list.o: ../common/list.c
-	$(CC) $(CFLAGS) -shared -c -o list.o ../common/list.c
+vpath %.c ../common
 
 X-wrapper-qubes: X-wrapper-qubes.o
 
 clean:
-	rm -f *~ *.o shmoverride.so X-wrapper-qubes
+	rm -f ./*~ ./*.o shmoverride.so X-wrapper-qubes
+
+%.o: %.c Makefile
+	$(CC) -MD -MP -MF $@.dep -c -o $@ $(extra_cflags) $(CFLAGS) $<
+-include *.dep

=== debian/changelog ===
qubes-gui-daemon (4.1.14-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 10 Jul 2021 05:27:16 +0200

qubes-gui-daemon (4.1.14-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Better build system
  * Reject MSG_MFNDUMP outside of dom0

  [ Marek Marczykowski-Górecki ]
  * Fix _NET_CURRENT_DESKTOP atom name
  * Fix monitoring working area changes

  [ Demi Marie Obenour ]
  * Obtain an XCB connection handle
  * Remove dependency on libxt
  * Exit if window attributes cannot be obtained
  * Fix typo in error string
  * Move null check to release_mapped_mfns
  * Avoid rogue screen locking
  * force_on_screen(): fix calculations
  * Use work area for available area calculation

  [ Marek Marczykowski-Górecki ]
  * Add convenient macro for iterating a list
  * Delete stale WM_TRANSIENT_FOR hint before mapping a window
  * Check if a window is referenced by another one before destroying it

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 10 Jul 2021 05:27:16 +0200

## qubes-gui-daemon 4.1.15

=== gui-daemon/Makefile ===
--- 
+++ 
@@ -26,12 +26,12 @@
 objs := xside.o png.o trayicon.o ../gui-common/double-buffer.o ../gui-common/txrx-vchan.o \
 	../gui-common/error.o list.o
 extra_cflags := -I../include/ -g -O2 -Wall -Wextra -Werror -pie -fPIC \
-		$(shell pkg-config --cflags $(pkgs))
+		$(shell pkg-config --cflags $(pkgs)) -fvisibility=hidden
 LDLIBS := $(shell pkg-config --libs $(pkgs))
 all: qubes-guid # qubes-guid.1
 vpath %.c ../common
 qubes-guid: $(objs)
-	$(CC) -g -pie -o qubes-guid $(objs) -Wall -lm $(LDLIBS) $(LDFLAGS)
+	$(CC) -g -pie -o qubes-guid $(objs) -Wall -lm $(LDLIBS) $(LDFLAGS) -Wl,-Bsymbolic
 
 qubes-guid.1: qubes-guid
 	LC_ALL=C help2man --version-string=`cat ../version` --no-info --name="Qubes GUI daemon" ./qubes-guid  > qubes-guid.1

=== pulse/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
+VCHAN_PKG = $(if $(BACKEND_VMM),vchan-$(BACKEND_VMM),vchan)
 CC ?= gcc
 CFLAGS += -Wall -Wextra -Werror -g -O2
-VCHANLIBS=`pkg-config --libs vchan-$(BACKEND_VMM)`
-VCHANCFLAGS=`pkg-config --cflags vchan-$(BACKEND_VMM)`
+VCHANLIBS=`pkg-config --libs $(VCHAN_PKG)`
+VCHANCFLAGS=`pkg-config --cflags $(VCHAN_PKG)`
 GLIBCFLAGS=`pkg-config --cflags glib-2.0`
 GLIBLIBS=`pkg-config --libs glib-2.0`
 all: module-vchan-sink.so pacat-simple-vchan

=== window-icon-updater/Makefile ===
all:
	@true

install:
	install -D icon-receiver $(DESTDIR)/usr/lib/qubes/icon-receiver
	ln -s /var/run/qubes/icon-receiver.sock $(DESTDIR)/etc/qubes-rpc/qubes.WindowIconUpdater
	install -m 0664 -D qubes.WindowIconUpdater.policy $(DESTDIR)/etc/qubes-rpc/policy/qubes.WindowIconUpdater
	install -d $(DESTDIR)/etc/qubes/rpc-config
	install -m 0664 -D qubes.WindowIconUpdater.config $(DESTDIR)/etc/qubes/rpc-config/qubes.WindowIconUpdater
	install -m 0664 -D qubes-icon-receiver.desktop $(DESTDIR)/etc/xdg/autostart/qubes-icon-receiver.desktop

=== debian/changelog ===
qubes-gui-daemon (4.1.15-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Tue, 24 Aug 2021 15:01:11 +0200

qubes-gui-daemon (4.1.15-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Use -fvisibility=hidden for building C
  * Add missing .PHONY dependencies
  * Miscellaneous cleanups; no change in behavior

  [ Marek Marczykowski-Górecki ]
  * zero-out msg_configure before filling it

  [ Demi Marie Obenour ]
  * Fix check for right/bottom border off screen
  * Add comments in do_shm_update

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 24 Aug 2021 15:01:11 +0200

## qubes-gui-daemon 4.1.16

=== debian/changelog ===
qubes-gui-daemon (4.1.16-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Mon, 27 Sep 2021 22:33:36 +0200

qubes-gui-daemon (4.1.16-1) unstable; urgency=medium

  * Ignore override-redirect in MSG_CONFIGURE
  * Prevent changing override-redirect of a mapped window
  * Do not allow docked override-redirect windows
  * Unmap window if really need to change override-redirect flag
  * Do not allow docking already mapped windows
  * Add reference counting child windows
  * Prevent docking or setting override-redirect on a non-toplevel
    window
  * Prevent docking or setting override-redirect on window with any
    child

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 27 Sep 2021 22:33:36 +0200

## qubes-gui-daemon 4.1.17

=== Makefile ===
--- 
+++ 
@@ -31,9 +31,13 @@
 	    echo "make clean                <--- clean all the binary files";\
 	    exit 0;
 
-all: gui-daemon/qubes-guid gui-daemon/qubes-guid.1 shmoverride/shmoverride.so \
+all_targets := gui-daemon/qubes-guid gui-daemon/qubes-guid.1 \
+     shmoverride/shmoverride.so \
      shmoverride/X-wrapper-qubes pulse/pacat-simple-vchan \
      screen-layout-handler/watch-screen-layout-changes
+
+all: $(all_targets)
+.PHONY: $(all_targets) install tar clean help
 
 gui-daemon/qubes-guid gui-daemon/qubes-guid.1:
 	$(MAKE) -C gui-daemon qubes-guid qubes-guid.1

=== shmoverride/Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 extra_cflags := -g -O2 -I../include/ -fPIC -Wall -Wextra -Werror \
 		-DBACKEND_VMM_$(BACKEND_VMM) \
 		-DSHMOVERRIDE_LIB_PATH=\"$(LIBDIR)/qubes-gui-daemon/shmoverride.so\" \
-		-I../include
+		-I../include -fvisibility=hidden
 CC=gcc
 
 all: shmoverride.so X-wrapper-qubes

=== debian/changelog ===
qubes-gui-daemon (4.1.17-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Wed, 29 Sep 2021 13:05:15 +0200

qubes-gui-daemon (4.1.17-1) unstable; urgency=medium

  * Set window background color to white
  * Do not ignore MSG_SHMIMAGE for a docked window
  * Unset override-redirect flag when docking, instead of preventing
    dock

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 29 Sep 2021 13:05:15 +0200

## qubes-gui-daemon 4.1.18

=== debian/changelog ===
qubes-gui-daemon (4.1.18-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 14 Oct 2021 18:46:36 +0200

qubes-gui-daemon (4.1.18-1) unstable; urgency=medium

  * rpm: add BR python3-setuptools
  * xside: move override-redirect windows back to allowed area

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 14 Oct 2021 18:46:36 +0200

## qubes-gui-daemon 4.1.19

=== debian/changelog ===
qubes-gui-daemon (4.1.19-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Tue, 09 Nov 2021 06:42:28 +0100

qubes-gui-daemon (4.1.19-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Flush after emergency move
  * Add FD_SETSIZE assertions

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 09 Nov 2021 06:42:28 +0100

## qubes-gui-daemon 4.1.20

=== Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 help:
 	@echo "Qubes GUI main Makefile:" ;\
 	    echo "make all                  <--- build binaries";\
-	    echo "make all                  <--- install files into \$$DESTDIR";\
+	    echo "make install              <--- install files into \$$DESTDIR";\
 	    echo "make clean                <--- clean all the binary files";\
 	    exit 0;

=== debian/changelog ===
qubes-gui-daemon (4.1.20-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Tue, 01 Mar 2022 04:07:14 +0100

qubes-gui-daemon (4.1.20-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Remove windows_count from Ghandles

  [ logoerthiner1 ]
  * Update pacat-simple-vchan.c
  * Apply suggestions from code review

  [ Marco De Donno ]
  * Typo in the help of the Makefile

  [ Demi Marie Obenour ]
  * Log invalid desktop or work area before exiting

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 01 Mar 2022 04:07:14 +0100

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,10 @@
  libvchan-xen-dev,
  python3-dev,
  libpulse-dev,
- libxt-dev,
  libxext-dev,
  libxrandr-dev,
+ libxcb1-dev,
+ libx11-xcb-dev,
  libconfig-dev,
  libpng-dev,
  libnotify-dev,

## qubes-gui-daemon 4.1.21

=== debian/changelog ===
qubes-gui-daemon (4.1.21-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Sat, 26 Mar 2022 14:28:38 +0100

qubes-gui-daemon (4.1.21-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Ignore bad work areas

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 26 Mar 2022 14:28:38 +0100

## qubes-gui-daemon 4.1.22

=== gui-daemon/Makefile ===
--- 
+++ 
@@ -26,7 +26,13 @@
 objs := xside.o png.o trayicon.o ../gui-common/double-buffer.o ../gui-common/txrx-vchan.o \
 	../gui-common/error.o list.o
 extra_cflags := -I../include/ -g -O2 -Wall -Wextra -Werror -pie -fPIC \
-		$(shell pkg-config --cflags $(pkgs)) -fvisibility=hidden
+		$(shell pkg-config --cflags $(pkgs)) \
+		-fvisibility=hidden \
+		-fno-strict-aliasing \
+		-fno-strict-overflow \
+		-fno-delete-null-pointer-checks \
+		-Wp,-D_FORTIFY_SOURCE=2
+
 LDLIBS := $(shell pkg-config --libs $(pkgs))
 all: qubes-guid # qubes-guid.1
 vpath %.c ../common

=== debian/changelog ===
qubes-gui-daemon (4.1.22-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Wed, 20 Jul 2022 12:12:18 +0200

qubes-gui-daemon (4.1.22-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Add some hardening CFLAGS
  * Disable subwindows by default
  * Add documentation for various guid.conf options

  [ Frédéric Pierret (fepitre) ]
  * Drop Travis CI
  * Add Qubes Builder v2 integration
  * .qubesbuilder: replace 'spec' by 'build'

  [ M. Vefa Bicakci ]
  * Release MFNs for unmapped windows as well

  [ unman ]
  * Rename Debian packages for consistency

  [ Demi Marie Obenour ]
  * Check the return value of snprintf()
  * Check XGetWindowAttributes return value
  * Bidirectional GUI protocol negotiation
  * Allow using older qubes-gui-protocol.h

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 20 Jul 2022 12:12:18 +0200

## qubes-gui-daemon 4.1.23

=== debian/changelog ===
qubes-gui-daemon (4.1.23-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Mon, 25 Jul 2022 18:04:37 +0200

qubes-gui-daemon (4.1.23-1) wheezy; urgency=medium

  * xside: do not release buffer of the "whole screen" window

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 25 Jul 2022 18:04:37 +0200

=== debian/control ===
--- 
+++ 
@@ -36,18 +36,28 @@
  ${shlibs:Depends},
  ${misc:Depends}
 Recommends:
- qubes-gui-daemon-pulseaudio
+ qubes-audio-daemon
 Provides: ${diverted-files}
 Conflicts: ${diverted-files}
 Description: Qubes GUI virtualization (GUI VM side)
  The Qubes GUI virtualization infrastructure that needs to be installed in GUI
  VM.
 
-Package: qubes-gui-daemon-pulseaudio
+Package: qubes-audio-daemon
 Architecture: any
 Depends:
  pulseaudio,
  ${shlibs:Depends},
  ${misc:Depends}
+Replaces: qubes-gui-daemon-pulseaudio (<< 4.1.21~)
+Breaks: qubes-gui-daemon-pulseaudio (<< 4.1.21~)
 Description: Qubes audio virtualization (GUI/Audio VM side)
  The GUI/Audio VM side of Qubes audio virtualization.
+
+Package: qubes-gui-daemon-pulseaudio
+Architecture: any
+Depends:
+ qubes-audio-daemon,
+ ${misc:Depends}
+Description: transitional package
+ This is a transitional package. It can safely be removed.

## qubes-gui-daemon 4.1.24

=== pulse/Makefile ===
--- 
+++ 
@@ -1,11 +1,11 @@
 VCHAN_PKG = $(if $(BACKEND_VMM),vchan-$(BACKEND_VMM),vchan)
 CC ?= gcc
-CFLAGS += -Wall -Wextra -Werror -g -O2
+CFLAGS += -Wall -Wextra -Werror -g -O2 -D_GNU_SOURCE=
 VCHANLIBS=`pkg-config --libs $(VCHAN_PKG)`
 VCHANCFLAGS=`pkg-config --cflags $(VCHAN_PKG)`
 GLIBCFLAGS=`pkg-config --cflags glib-2.0`
 GLIBLIBS=`pkg-config --libs glib-2.0`
-all: module-vchan-sink.so pacat-simple-vchan
+all: pacat-simple-vchan
 pacat-simple-vchan.o: pacat-simple-vchan.c
 	$(CC) $(CFLAGS) -c $(VCHANCFLAGS) -I. $(GLIBCFLAGS) pacat-simple-vchan.c
 pacat-simple-vchan: pacat-simple-vchan.o

=== debian/changelog ===
qubes-gui-daemon (4.1.24-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Tue, 30 Aug 2022 12:45:18 +0200

qubes-gui-daemon (4.1.24-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Properly check return value of snprintf()
  * Fix command line parsing
  * process_playback_data(): avoid blocking on vchan reads
  * send_rec_data(): Avoid blocking on vchan writes
  * Properly handle control connection errors
  * Only check for newlines in newly read data
  * Log an error for invalid control commands
  * Move definition of _GNU_SOURCE to the makefile
  * Prevent PulseAudio assertion failure
  * Do not try to build vchan sink module
  * Block during writing for old agents
  * Use original loop for writing data
  * Minor cleanups
  * Send MSG_DESTROY when destroying a window
  * Send MSG_DESTROY when destroying a window

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 30 Aug 2022 12:45:18 +0200

## qubes-gui-daemon 4.1.25

=== debian/changelog ===
qubes-gui-daemon (4.1.25-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Mon, 17 Oct 2022 17:51:43 +0200

qubes-gui-daemon (4.1.25-1) unstable; urgency=medium

  [ Marta Marczykowska-Górecka ]
  * Fix notification to comply with summary/body format

  [ Demi Marie Obenour ]
  * Actually unset override-redirect when docking

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 17 Oct 2022 17:51:43 +0200

## qubes-gui-daemon 4.1.26

=== debian/changelog ===
qubes-gui-daemon (4.1.26-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Tue, 07 Feb 2023 16:17:37 +0100

qubes-gui-daemon (4.1.26-1) unstable; urgency=medium

  * Rebuild for bookworm

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 07 Feb 2023 16:17:37 +0100

## qubes-gui-daemon 4.2.0

=== debian/changelog ===
qubes-gui-daemon (4.2.0-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Fri, 02 Dec 2022 05:31:44 +0100

qubes-gui-daemon (4.2.0-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Actually unset override-redirect when docking
  * Support pipewire-pulseaudio as well as pulseaudio

  [ Marta Marczykowska-Górecka ]
  * Fix notification to comply with summary/body format

  [ Demi Marie Obenour ]
  * Make the build system a bit better
  * Add assertions and comments in do_shm_update
  * Do not check for WM_STATE changes on the root window
  * Strict validation of domain IDs
  * GUI daemon does not take non-option arguments
  * Fix unchecked malloc()
  * Obtain an XCB graphics context
  * Switch from Xlib to XCB for shared memory
  * Update shmoverride/README for Xlib → xcb change
  * Use FD passing for shared memory
  * shmoverride: avoid keeping state for munmap
  * Remove remaining use of System V shared memory
  * Better logging and command-line parsing
  * Clean up some macros
  * Fix function prototype mismatches and use poll(2)

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 02 Dec 2022 05:31:44 +0100

## qubes-gui-daemon 4.2.1

=== Makefile ===
--- 
+++ 
@@ -79,3 +79,4 @@
 	(cd shmoverride; $(MAKE) clean)
 	$(MAKE) -C pulse clean
 
+.PHONY: all clean tar install help

=== gui-daemon/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 MAKEFLAGS := -rR
 VCHAN_PKG = $(if $(BACKEND_VMM),vchan-$(BACKEND_VMM),vchan)
 CC=gcc
-pkgs := x11 xext x11-xcb xcb glib-2.0 $(VCHAN_PKG) libpng libnotify libconfig
+pkgs := x11 x11-xcb xcb xcb-shm xcb-aux glib-2.0 $(VCHAN_PKG) libpng libnotify libconfig
 objs := xside.o png.o trayicon.o ../gui-common/double-buffer.o ../gui-common/txrx-vchan.o \
 	../gui-common/error.o list.o
 extra_cflags := -I../include/ -g -O2 -Wall -Wextra -Werror -pie -fPIC \
@@ -31,7 +31,7 @@
 		-fno-strict-aliasing \
 		-fno-strict-overflow \
 		-fno-delete-null-pointer-checks \
-		-Wp,-D_FORTIFY_SOURCE=2
+		-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GNU_SOURCE -Werror=missing-prototypes
 
 LDLIBS := $(shell pkg-config --libs $(pkgs))
 all: qubes-guid # qubes-guid.1

=== debian/changelog ===
qubes-gui-daemon (4.2.1-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Mon, 09 Jan 2023 19:49:08 +0100

qubes-gui-daemon (4.2.1-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Fix some -Wconversion warnings
  * Remove unneeded header includes
  * Rip out subwindows support

  [ Marek Marczykowski-Górecki ]
  * pulse: Fix indentation
  * Deal with delayed pulseaudio agent startup
  * rpm: drop explicit libvchan dependency
  * ci: drop R4.1

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 09 Jan 2023 19:49:08 +0100

## qubes-gui-daemon 4.2.2

=== debian/changelog ===
qubes-gui-daemon (4.2.2-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Fri, 03 Feb 2023 19:22:41 +0100

qubes-gui-daemon (4.2.2-1) unstable; urgency=medium

  * rpm: fix files ownership on install
  * Use new qrexec policy format

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 03 Feb 2023 19:22:41 +0100

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,10 @@
  libvchan-xen-dev,
  python3-dev,
  libpulse-dev,
- libxext-dev,
  libxrandr-dev,
  libxcb1-dev,
+ libxcb-util0-dev,
+ libxcb-shm0-dev,
  libx11-xcb-dev,
  libconfig-dev,
  libpng-dev,
@@ -21,8 +22,8 @@
  help2man
 Standards-Version: 4.1.3
 Homepage: https://qubes-os.org/
-#Vcs-Browser: https://github.com/QubesOS/qubes-gui-daemon
-#Vcs-Git: https://github.com/QubesOS/qubes-gui-daemon.git
+Vcs-Browser: https://github.com/QubesOS/qubes-gui-daemon
+Vcs-Git: https://github.com/QubesOS/qubes-gui-daemon.git
 
 Package: qubes-gui-daemon
 Architecture: any

## qubes-gui-daemon 4.2.3

=== Makefile ===
--- 
+++ 
@@ -64,7 +64,7 @@
 	install -D shmoverride/shmoverride.so $(DESTDIR)$(LIBDIR)/qubes-gui-daemon/shmoverride.so
 	install -D -m 0644 gui-daemon/guid.conf $(DESTDIR)/etc/qubes/guid.conf
 	install -D gui-daemon/qubes-localgroup.sh $(DESTDIR)/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
-	install -D -m 0644 gui-daemon/qubes.ClipboardPaste.policy $(DESTDIR)/etc/qubes-rpc/policy/qubes.ClipboardPaste
+	install -D -m 0644 common/90-default-gui-daemon.policy $(DESTDIR)/etc/qubes/policy.d/90-default-gui-daemon.policy
 	install -D screen-layout-handler/watch-screen-layout-changes $(DESTDIR)/usr/libexec/qubes/watch-screen-layout-changes
 	install -D -m 0644 screen-layout-handler/qubes-screen-layout-watches.desktop $(DESTDIR)/etc/xdg/autostart/qubes-screen-layout-watches.desktop
 	$(MAKE) -C window-icon-updater install

=== debian/changelog ===
qubes-gui-daemon (4.2.3-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Thu, 27 Apr 2023 14:37:16 +0200

qubes-gui-daemon (4.2.3-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * do_shm_update: Negative width or height is an error
  * Fix a typo in a comment
  * Do not read a message unless a header is ready
  * Do not use VERIFY with partially-read messages
  * Earlier validation of MSG_WINDOW_DUMP sizes
  * Strictly validate message lengths
  * Drain playback stream before corking it
  * Do not cork a playback stream with nonempty buffers
  * Allow selecting blocking or non-blocking I/O
  * ACK all grant mappings
  * Avoid hard-coding protocol versions
  * Do not send MSG_DESTROY to agents that aren't expecting it
  * Ensure notifications conform to header-body format

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 27 Apr 2023 14:37:16 +0200

## qubes-gui-daemon 4.2.4

=== debian/changelog ===
qubes-gui-daemon (4.2.4-1+deb13u1) trixie; urgency=medium

  * Build for trixie

 -- Builder <user@localhost>  Thu, 11 Jan 2024 03:05:10 +0100

qubes-gui-daemon (4.2.4-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Allow periods in qube names

  [ Marek Marczykowski-Górecki ]
  * Revert "Allow periods in qube names"

  [ Demi Marie Obenour ]
  * Do not crash if the work area is invalid

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 11 Jan 2024 03:05:10 +0100

## qubes-gui-daemon 4.2.5

=== debian/changelog ===
qubes-gui-daemon (4.2.5-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Mon, 05 Feb 2024 04:29:18 +0100

qubes-gui-daemon (4.2.5-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Always block on vchan I/O by default

  [ Marek Marczykowski-Górecki ]
  * shmoverride: fix parameters order

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 05 Feb 2024 04:29:18 +0100
